'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _RootPage = require('../../../styles/cspace-ui/RootPage.css');

var _RootPage2 = _interopRequireDefault(_RootPage);

var _favicon = require('../../../images/favicon.png');

var _favicon2 = _interopRequireDefault(_favicon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  title: {
    'id': 'rootPage.title',
    'defaultMessage': 'CollectionSpace'
  }
});

var propTypes = {
  children: _react.PropTypes.node,
  className: _react.PropTypes.string,
  intl: _reactIntl.intlShape
};

function RootPage(props) {
  var children = props.children,
      className = props.className,
      intl = props.intl;


  var classes = (0, _classnames2.default)(_RootPage2.default.common, className);

  return _react2.default.createElement(
    'div',
    { className: classes },
    _react2.default.createElement(
      _reactHelmet2.default,
      null,
      _react2.default.createElement(
        'title',
        null,
        intl.formatMessage(messages.title)
      ),
      _react2.default.createElement('link', { rel: 'shortcut icon', href: _favicon2.default })
    ),
    children
  );
}

RootPage.propTypes = propTypes;

exports.default = (0, _reactIntl.injectIntl)(RootPage);