'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = BackButton;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

var _BackButton = require('../../../styles/cspace-ui/BackButton.css');

var _BackButton2 = _interopRequireDefault(_BackButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = _cspaceInput.components.Button;


var messages = (0, _reactIntl.defineMessages)({
  label: {
    'id': 'backButton.label',
    'defaultMessage': 'Back'
  }
});

var propTypes = {
  label: _react.PropTypes.node,
  onClick: _react.PropTypes.func
};

var defaultProps = {
  label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.label)
};

function BackButton(props) {
  var label = props.label,
      onClick = props.onClick;


  return _react2.default.createElement(
    Button,
    {
      className: _BackButton2.default.common,
      icon: true,
      name: 'back',
      onClick: onClick
    },
    label
  );
}

BackButton.propTypes = propTypes;
BackButton.defaultProps = defaultProps;