'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CancelButton;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

var _CancelButton = require('../../../styles/cspace-ui/CancelButton.css');

var _CancelButton2 = _interopRequireDefault(_CancelButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = _cspaceInput.components.Button;


var messages = (0, _reactIntl.defineMessages)({
  label: {
    'id': 'cancelButton.label',
    'defaultMessage': 'Cancel'
  }
});

var propTypes = {
  onClick: _react.PropTypes.func
};

function CancelButton(props) {
  var onClick = props.onClick;


  return _react2.default.createElement(
    Button,
    {
      className: _CancelButton2.default.common,
      icon: true,
      name: 'cancel',
      onClick: onClick
    },
    _react2.default.createElement(_reactIntl.FormattedMessage, messages.label)
  );
}

CancelButton.propTypes = propTypes;