'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _RecordButtonBar = require('./RecordButtonBar');

var _RecordButtonBar2 = _interopRequireDefault(_RecordButtonBar);

var _RecordHistory = require('./RecordHistory');

var _RecordHistory2 = _interopRequireDefault(_RecordHistory);

var _recordDataHelpers = require('../../helpers/recordDataHelpers');

var _RecordEditor = require('../../../styles/cspace-ui/RecordEditor.css');

var _RecordEditor2 = _interopRequireDefault(_RecordEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function renderTemplate(component, messages, handlers) {
  var overrideProps = {};
  var type = component.type;

  if (type) {
    var _propTypes = type.propTypes;

    if (_propTypes) {
      Object.keys(handlers).forEach(function (handlerName) {
        if (_propTypes[handlerName] && !component.props[handlerName]) {
          overrideProps[handlerName] = handlers[handlerName];
        }
      });
    }
  }

  return _react2.default.cloneElement(component, overrideProps, _react2.default.Children.map(component.props.children, function (child) {
    return renderTemplate(child, messages, handlers);
  }));
}

var propTypes = {
  config: _react.PropTypes.object,
  recordType: _react.PropTypes.string.isRequired,
  vocabulary: _react.PropTypes.string,
  csid: _react.PropTypes.string,
  cloneCsid: _react.PropTypes.string,
  data: _react.PropTypes.instanceOf(_immutable2.default.Map),
  isModified: _react.PropTypes.bool,
  isSavePending: _react.PropTypes.bool,
  createNewRecord: _react.PropTypes.func,
  readRecord: _react.PropTypes.func,
  onAddInstance: _react.PropTypes.func,
  onCommit: _react.PropTypes.func,
  onMoveInstance: _react.PropTypes.func,
  onRemoveInstance: _react.PropTypes.func,
  onRecordCreated: _react.PropTypes.func,
  save: _react.PropTypes.func,
  revert: _react.PropTypes.func,
  clone: _react.PropTypes.func
};

var defaultProps = {
  data: _immutable2.default.Map()
};

var childContextTypes = {
  config: _react.PropTypes.object,
  recordType: _react.PropTypes.string,
  vocabulary: _react.PropTypes.string,
  csid: _react.PropTypes.string
};

var RecordEditor = function (_Component) {
  _inherits(RecordEditor, _Component);

  function RecordEditor() {
    _classCallCheck(this, RecordEditor);

    var _this = _possibleConstructorReturn(this, (RecordEditor.__proto__ || Object.getPrototypeOf(RecordEditor)).call(this));

    _this.handleSaveButtonClick = _this.handleSaveButtonClick.bind(_this);
    _this.handleRevertButtonClick = _this.handleRevertButtonClick.bind(_this);
    _this.handleCloneButtonClick = _this.handleCloneButtonClick.bind(_this);
    return _this;
  }

  _createClass(RecordEditor, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _props = this.props,
          config = _props.config,
          csid = _props.csid,
          recordType = _props.recordType,
          vocabulary = _props.vocabulary;


      return {
        config: config,
        csid: csid,
        recordType: recordType,
        vocabulary: vocabulary
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initRecord();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props,
          recordType = _props2.recordType,
          vocabulary = _props2.vocabulary,
          csid = _props2.csid,
          cloneCsid = _props2.cloneCsid;
      var prevRecordType = prevProps.recordType,
          prevVocabulary = prevProps.vocabulary,
          prevCsid = prevProps.csid,
          prevCloneCsid = prevProps.cloneCsid;


      if (recordType !== prevRecordType || vocabulary !== prevVocabulary || csid !== prevCsid || cloneCsid !== prevCloneCsid) {
        this.initRecord();
      }
    }
  }, {
    key: 'initRecord',
    value: function initRecord() {
      var _props3 = this.props,
          csid = _props3.csid,
          cloneCsid = _props3.cloneCsid,
          createNewRecord = _props3.createNewRecord,
          readRecord = _props3.readRecord;


      if (csid) {
        if (readRecord) {
          readRecord();
        }
      } else if (createNewRecord) {
        createNewRecord(cloneCsid);
      }
    }
  }, {
    key: 'handleCloneButtonClick',
    value: function handleCloneButtonClick() {
      var _props4 = this.props,
          clone = _props4.clone,
          csid = _props4.csid;


      if (clone) {
        clone(csid);
      }
    }
  }, {
    key: 'handleRevertButtonClick',
    value: function handleRevertButtonClick() {
      var revert = this.props.revert;


      if (revert) {
        revert();
      }
    }
  }, {
    key: 'handleSaveButtonClick',
    value: function handleSaveButtonClick() {
      var _props5 = this.props,
          save = _props5.save,
          onRecordCreated = _props5.onRecordCreated;


      if (save) {
        save(onRecordCreated);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props6 = this.props,
          config = _props6.config,
          csid = _props6.csid,
          data = _props6.data,
          isModified = _props6.isModified,
          isSavePending = _props6.isSavePending,
          recordType = _props6.recordType,
          onAddInstance = _props6.onAddInstance,
          onCommit = _props6.onCommit,
          onMoveInstance = _props6.onMoveInstance,
          onRemoveInstance = _props6.onRemoveInstance;


      var recordTypeConfig = config.recordTypes[recordType];

      if (!recordTypeConfig) {
        return null;
      }

      var forms = recordTypeConfig.forms,
          messages = recordTypeConfig.messages;


      var handlers = {
        onAddInstance: onAddInstance,
        onCommit: onCommit,
        onMoveInstance: onMoveInstance,
        onRemoveInstance: onRemoveInstance
      };

      var formTemplate = forms.default;

      var formContent = _react2.default.cloneElement(formTemplate, {
        name: _recordDataHelpers.DOCUMENT_PROPERTY_NAME,
        value: data.get(_recordDataHelpers.DOCUMENT_PROPERTY_NAME),
        children: _react2.default.Children.map(formTemplate.props.children, function (child) {
          return renderTemplate(child, messages, handlers);
        })
      });

      return _react2.default.createElement(
        'form',
        {
          autoComplete: 'off',
          className: _RecordEditor2.default.common
        },
        _react2.default.createElement(
          'header',
          null,
          _react2.default.createElement(_RecordButtonBar2.default, {
            csid: csid,
            isModified: isModified,
            isSavePending: isSavePending,
            onSaveButtonClick: this.handleSaveButtonClick,
            onRevertButtonClick: this.handleRevertButtonClick,
            onCloneButtonClick: this.handleCloneButtonClick
          }),
          _react2.default.createElement(_RecordHistory2.default, {
            data: data,
            isModified: isModified,
            isSavePending: isSavePending
          })
        ),
        formContent,
        _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(_RecordButtonBar2.default, {
            csid: csid,
            isModified: isModified,
            isSavePending: isSavePending,
            onSaveButtonClick: this.handleSaveButtonClick,
            onRevertButtonClick: this.handleRevertButtonClick,
            onCloneButtonClick: this.handleCloneButtonClick
          })
        )
      );
    }
  }]);

  return RecordEditor;
}(_react.Component);

exports.default = RecordEditor;


RecordEditor.propTypes = propTypes;
RecordEditor.defaultProps = defaultProps;
RecordEditor.childContextTypes = childContextTypes;