'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RelationButtonBar;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _reactRouter = require('react-router');

var _CancelButton = require('./CancelButton');

var _CancelButton2 = _interopRequireDefault(_CancelButton);

var _CloseButton = require('./CloseButton');

var _CloseButton2 = _interopRequireDefault(_CloseButton);

var _UnrelateButton = require('./UnrelateButton');

var _UnrelateButton2 = _interopRequireDefault(_UnrelateButton);

var _ButtonBar = require('../../../styles/cspace-ui/ButtonBar.css');

var _ButtonBar2 = _interopRequireDefault(_ButtonBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  open: {
    'id': 'relationButtonBar.open',
    'defaultMessage': 'Open'
  }
});

var propTypes = {
  // TODO: These uses aren't properly detected. Try updating eslint-plugin-react.
  /* eslint-disable react/no-unused-prop-types */
  object: _react.PropTypes.shape({
    csid: _react.PropTypes.string,
    recordType: _react.PropTypes.string
  }),
  /* eslint-enable react/no-unused-prop-types */
  onCancelButtonClick: _react.PropTypes.func,
  onCloseButtonClick: _react.PropTypes.func,
  onUnrelateButtonClick: _react.PropTypes.func
};

function RelationButtonBar(props) {
  var object = props.object,
      onCancelButtonClick = props.onCancelButtonClick,
      onCloseButtonClick = props.onCloseButtonClick,
      onUnrelateButtonClick = props.onUnrelateButtonClick;


  var objectCsid = object ? object.csid : undefined;

  var cancelButton = objectCsid ? null : _react2.default.createElement(_CancelButton2.default, { onClick: onCancelButtonClick });
  var closeButton = objectCsid ? _react2.default.createElement(_CloseButton2.default, { onClick: onCloseButtonClick }) : null;
  var unrelateButton = objectCsid ? _react2.default.createElement(_UnrelateButton2.default, { onClick: onUnrelateButtonClick }) : null;

  var openLink = void 0;

  if (objectCsid) {
    openLink = _react2.default.createElement(
      _reactRouter.Link,
      { to: '/record/' + object.recordType + '/' + object.csid },
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.open)
    );
  }

  return _react2.default.createElement(
    'div',
    { className: _ButtonBar2.default.common },
    openLink,
    cancelButton,
    unrelateButton,
    closeButton
  );
}

RelationButtonBar.propTypes = propTypes;