'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseTypedHierarchyEditor = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _cspaceInput = require('cspace-input');

var _AutocompleteInputContainer = require('../../containers/input/AutocompleteInputContainer');

var _AutocompleteInputContainer2 = _interopRequireDefault(_AutocompleteInputContainer);

var _OptionListControlledInputContainer = require('../../containers/input/OptionListControlledInputContainer');

var _OptionListControlledInputContainer2 = _interopRequireDefault(_OptionListControlledInputContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CompoundInput = _cspaceInput.components.CompoundInput,
    InputTable = _cspaceInput.components.InputTable;


var propTypes = {
  csid: _react.PropTypes.string,
  intl: _reactIntl.intlShape,
  messages: _react.PropTypes.object,
  recordType: _react.PropTypes.string,
  vocabulary: _react.PropTypes.string,
  value: _react.PropTypes.instanceOf(_immutable2.default.Map),
  parentTypeOptionListName: _react.PropTypes.string,
  childTypeOptionListName: _react.PropTypes.string,
  onCommit: _react.PropTypes.func,
  onAddChild: _react.PropTypes.func,
  onRemoveChild: _react.PropTypes.func
};

var BaseTypedHierarchyEditor = exports.BaseTypedHierarchyEditor = function (_Component) {
  _inherits(BaseTypedHierarchyEditor, _Component);

  function BaseTypedHierarchyEditor() {
    _classCallCheck(this, BaseTypedHierarchyEditor);

    var _this = _possibleConstructorReturn(this, (BaseTypedHierarchyEditor.__proto__ || Object.getPrototypeOf(BaseTypedHierarchyEditor)).call(this));

    _this.filterMatch = _this.filterMatch.bind(_this);
    _this.handleAddChild = _this.handleAddChild.bind(_this);
    _this.handleRemoveChild = _this.handleRemoveChild.bind(_this);
    _this.handleChildRefNameCommit = _this.handleChildRefNameCommit.bind(_this);
    _this.handleChildTypeCommit = _this.handleChildTypeCommit.bind(_this);
    _this.handleParentRefNameCommit = _this.handleParentRefNameCommit.bind(_this);
    _this.handleParentTypeCommit = _this.handleParentTypeCommit.bind(_this);
    return _this;
  }

  _createClass(BaseTypedHierarchyEditor, [{
    key: 'filterMatch',
    value: function filterMatch(item) {
      return item.csid !== this.props.csid;
    }
  }, {
    key: 'handleAddChild',
    value: function handleAddChild() {
      var onAddChild = this.props.onAddChild;


      if (onAddChild) {
        onAddChild();
      }
    }
  }, {
    key: 'handleRemoveChild',
    value: function handleRemoveChild(path) {
      var onRemoveChild = this.props.onRemoveChild;


      if (onRemoveChild) {
        var position = parseInt(path[path.length - 1], 10);

        onRemoveChild(position);
      }
    }
  }, {
    key: 'handleChildRefNameCommit',
    value: function handleChildRefNameCommit(path, value) {
      var onCommit = this.props.onCommit;


      if (onCommit) {
        var index = path[0];

        onCommit(['children', index, 'refName'], value);
      }
    }
  }, {
    key: 'handleChildTypeCommit',
    value: function handleChildTypeCommit(path, value) {
      var onCommit = this.props.onCommit;


      if (onCommit) {
        var index = path[0];

        onCommit(['children', index, 'type'], value);
      }
    }
  }, {
    key: 'handleParentRefNameCommit',
    value: function handleParentRefNameCommit(path, value, csid) {
      var _props = this.props,
          hierarchy = _props.value,
          onCommit = _props.onCommit;


      var parent = hierarchy.get('parent');

      if (onCommit) {
        onCommit(['parent'], parent.set('refName', value).set('csid', csid));
      }
    }
  }, {
    key: 'handleParentTypeCommit',
    value: function handleParentTypeCommit(path, value) {
      var onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit(['parent', 'type'], value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          intl = _props2.intl,
          messages = _props2.messages,
          recordType = _props2.recordType,
          vocabulary = _props2.vocabulary,
          value = _props2.value,
          parentTypeOptionListName = _props2.parentTypeOptionListName,
          childTypeOptionListName = _props2.childTypeOptionListName;


      var source = [recordType, vocabulary].join('/');
      var parentRefName = value.getIn(['parent', 'refName']);
      var parentType = value.getIn(['parent', 'type']);

      var children = value.get('children');

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          InputTable,
          null,
          _react2.default.createElement(_AutocompleteInputContainer2.default, {
            label: intl.formatMessage(messages.parent),
            name: 'parentRefName',
            source: source,
            value: parentRefName,
            onCommit: this.handleParentRefNameCommit,
            matchFilter: this.filterMatch
          }),
          _react2.default.createElement(_OptionListControlledInputContainer2.default, {
            label: intl.formatMessage(messages.parentType),
            name: 'parentType',
            optionListName: parentTypeOptionListName,
            value: parentType,
            onCommit: this.handleParentTypeCommit
          })
        ),
        _react2.default.createElement(
          CompoundInput,
          {
            label: intl.formatMessage(messages.children),
            value: children
          },
          _react2.default.createElement(
            CompoundInput,
            {
              tabular: true,
              repeating: true,
              reorderable: false,
              onAddInstance: this.handleAddChild,
              onRemoveInstance: this.handleRemoveChild
            },
            _react2.default.createElement(_AutocompleteInputContainer2.default, {
              label: intl.formatMessage(messages.child),
              name: 'refName',
              source: source,
              matchFilter: this.filterMatch,
              onCommit: this.handleChildRefNameCommit
            }),
            _react2.default.createElement(_OptionListControlledInputContainer2.default, {
              label: intl.formatMessage(messages.childType),
              name: 'type',
              optionListName: childTypeOptionListName,
              onCommit: this.handleChildTypeCommit
            })
          )
        )
      );
    }
  }]);

  return BaseTypedHierarchyEditor;
}(_react.Component);

BaseTypedHierarchyEditor.propTypes = propTypes;

exports.default = (0, _reactIntl.injectIntl)(BaseTypedHierarchyEditor);