'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'objectNumber',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.default.objectNumber',
        'defaultMessage': 'Identification number'
      }
    }),
    sortBy: 'collectionobjects_common:objectNumber',
    width: 200
  }, {
    name: 'title',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.default.title',
        'defaultMessage': 'Title'
      }
    }),
    sortBy: 'collectionobjects_common:titleGroupList/0/title',
    width: 450
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.default.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }],
  narrow: [{
    name: 'objectNumber',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.narrow.objectNumber',
        'defaultMessage': 'ID'
      }
    }),
    sortBy: 'collectionobjects_common:objectNumber',
    width: 200
  }, {
    name: 'title',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.narrow.title',
        'defaultMessage': 'Title'
      }
    }),
    width: 450
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.collectionobject.narrow.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};