'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = function (pluginContext) {
  var _ns2RelationsCommon, _otherNumber, _otherNumberList, _responsibleDepartmen2, _briefDescriptions, _comments, _titleTranslationSubG, _titleTranslationSubG2, _titleGroup, _titleGroupList, _objectNameGroup, _objectNameList, _objectStatusList, _forms, _styles, _colors, _materialGroup, _materialGroupList, _objectComponentGroup, _objectComponentGroup2, _technicalAttributeGr, _technicalAttributeGr2, _dimensionSubGroup, _dimensionSubGroupLis, _measuredPartGroup, _measuredPartGroupLis, _contentLanguages, _contentActivities, _contentConcepts, _contentPositions, _contentObjectGroup, _contentObjectGroupLi, _contentPeoples, _contentPersons, _contentPlaces, _contentScripts, _contentOrganizations, _contentEventNameGrou, _contentEventNameGrou2, _contentOtherGroup, _contentOtherGroupLis, _textualInscriptionGr, _textualInscriptionGr2, _nonTextualInscriptio, _nonTextualInscriptio2, _objectProductionDate2, _techniqueGroup, _techniqueGroupList, _objectProductionPlac3, _objectProductionPlac4, _objectProductionReas2, _objectProductionPeop3, _objectProductionPeop4, _objectProductionPers3, _objectProductionPers4, _objectProductionOrga3, _objectProductionOrga4, _assocActivityGroup, _assocActivityGroupLi, _assocObjectGroup, _assocObjectGroupList, _assocConceptGroup, _assocConceptGroupLis, _assocCulturalContext4, _assocCulturalContext5, _assocOrganizationGro, _assocOrganizationGro2, _assocPeopleGroup, _assocPeopleGroupList, _assocPersonGroup, _assocPersonGroupList, _assocPlaceGroup, _assocPlaceGroupList, _assocEventOrganizati2, _assocEventPeoples, _assocEventPersons, _assocEventPlaces, _assocDateGroup, _assocDateGroupList, _usageGroup, _usageGroupList, _owners, _ownershipDateGroupLi, _ownersReferences, _viewersReferences, _referenceGroup, _referenceGroupList, _fieldCollectionMetho2, _fieldCollectionSourc2, _fieldCollectors, _fieldColEventNames, _ns2Collectionobject, _document;

  var _pluginContext$inputC = pluginContext.inputComponents,
      AutocompleteInput = _pluginContext$inputC.AutocompleteInput,
      CompoundInput = _pluginContext$inputC.CompoundInput,
      DateInput = _pluginContext$inputC.DateInput,
      HierarchyInput = _pluginContext$inputC.HierarchyInput,
      IDGeneratorInput = _pluginContext$inputC.IDGeneratorInput,
      OptionListControlledInput = _pluginContext$inputC.OptionListControlledInput,
      StructuredDateInput = _pluginContext$inputC.StructuredDateInput,
      TextInput = _pluginContext$inputC.TextInput,
      VocabularyControlledInput = _pluginContext$inputC.VocabularyControlledInput;
  var config = pluginContext.configHelpers.configKey;
  var _pluginContext$dataTy = pluginContext.dataTypes,
      DATA_TYPE_LIST = _pluginContext$dataTy.DATA_TYPE_LIST,
      DATA_TYPE_INT = _pluginContext$dataTy.DATA_TYPE_INT,
      DATA_TYPE_FLOAT = _pluginContext$dataTy.DATA_TYPE_FLOAT,
      DATA_TYPE_DATETIME = _pluginContext$dataTy.DATA_TYPE_DATETIME;


  return {
    document: (_document = {}, _defineProperty(_document, config, {
      view: {
        type: CompoundInput,
        props: {
          defaultChildSubpath: 'ns2:collectionobjects_common'
        }
      }
    }), _defineProperty(_document, 'ns2:collectionspace_core', {
      createdAt: _defineProperty({}, config, {
        dataType: DATA_TYPE_DATETIME,
        view: {
          type: DateInput
        }
      }),
      createdBy: _defineProperty({}, config, {
        view: {
          type: TextInput
        }
      }),
      updatedAt: _defineProperty({}, config, {
        dataType: DATA_TYPE_DATETIME,
        messages: (0, _reactIntl.defineMessages)({
          name: {
            'id': 'field.collectionspace_core.updatedAt.name',
            'defaultMessage': 'Last updated time'
          }
        }),
        view: {
          type: DateInput
        }
      }),
      updatedBy: _defineProperty({}, config, {
        messages: (0, _reactIntl.defineMessages)({
          name: {
            'id': 'field.collectionspace_core.updatedBy.name',
            'defaultMessage': 'Last updated by'
          }
        }),
        view: {
          type: TextInput
        }
      })
    }), _defineProperty(_document, 'ns2:relations-common-list', (_ns2RelationsCommon = {}, _defineProperty(_ns2RelationsCommon, config, {
      service: {
        ns: 'http://collectionspace.org/services/relation'
      }
    }), _defineProperty(_ns2RelationsCommon, 'relation-list-item', _defineProperty({}, config, {
      view: {
        type: HierarchyInput,
        props: {
          parentTypeOptionListName: 'objectParentTypes',
          childTypeOptionListName: 'objectChildTypes',
          messages: (0, _reactIntl.defineMessages)({
            parent: {
              'id': 'hierarchyInput.collectionobject.parent',
              'defaultMessage': 'Broader object'
            },
            parentType: {
              'id': 'hierarchyInput.collectionobject.parentType',
              'defaultMessage': 'Type'
            },
            children: {
              'id': 'hierarchyInput.collectionobject.children',
              'defaultMessage': 'Component objects'
            },
            child: {
              'id': 'hierarchyInput.collectionobject.child',
              'defaultMessage': 'Object'
            },
            childType: {
              'id': 'hierarchyInput.collectionobject.childType',
              'defaultMessage': 'Type'
            },
            siblings: {
              'id': 'hierarchyInput.collectionobject.siblings',
              'defaultMessage': 'Adjacent objects'
            }
          })
        }
      }
    })), _ns2RelationsCommon)), _defineProperty(_document, 'ns2:collectionobjects_common', (_ns2Collectionobject = {}, _defineProperty(_ns2Collectionobject, config, {
      service: {
        ns: 'http://collectionspace.org/services/collectionobject'
      }
    }), _defineProperty(_ns2Collectionobject, 'objectNumber', _defineProperty({}, config, {
      cloneable: false,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNumber.name',
          'defaultMessage': 'Identification number'
        }
      }),
      searchView: {
        type: TextInput
      },
      view: {
        type: IDGeneratorInput,
        props: {
          idGeneratorName: 'accession,intake,loanin'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'numberOfObjects', _defineProperty({}, config, {
      dataType: DATA_TYPE_INT,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.numberOfObjects.name',
          'defaultMessage': 'Number of objects'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'otherNumberList', (_otherNumberList = {}, _defineProperty(_otherNumberList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.otherNumberList.name',
          'defaultMessage': 'Other number'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_otherNumberList, 'otherNumber', (_otherNumber = {}, _defineProperty(_otherNumber, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_otherNumber, 'numberValue', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.numberValue.name',
          'defaultMessage': 'Number'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_otherNumber, 'numberType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.numberType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'numberTypes'
        }
      }
    })), _otherNumber)), _otherNumberList)), _defineProperty(_ns2Collectionobject, 'responsibleDepartments', (_responsibleDepartmen2 = {}, _defineProperty(_responsibleDepartmen2, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.responsibleDepartments.name',
          'defaultMessage': 'Responsible department'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_responsibleDepartmen2, 'responsibleDepartment', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.responsibleDepartment.fullName',
          'defaultMessage': 'Responsible department'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'departments',
          repeating: true
        }
      }
    })), _responsibleDepartmen2)), _defineProperty(_ns2Collectionobject, 'collection', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.collection.name',
          'defaultMessage': 'Collection'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'collections'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'recordStatus', _defineProperty({}, config, {
      defaultValue: 'new',
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.recordStatus.name',
          'defaultMessage': 'Record status'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'recordStatuses'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'briefDescriptions', (_briefDescriptions = {}, _defineProperty(_briefDescriptions, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.briefDescriptions.name',
          'defaultMessage': 'Brief description'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_briefDescriptions, 'briefDescription', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          multiline: true,
          repeating: true
        }
      }
    })), _briefDescriptions)), _defineProperty(_ns2Collectionobject, 'distinguishingFeatures', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.distinguishingFeatures.name',
          'defaultMessage': 'Distinguishing features'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'comments', (_comments = {}, _defineProperty(_comments, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.comments.name',
          'defaultMessage': 'Comment'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_comments, 'comment', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          multiline: true,
          repeating: true
        }
      }
    })), _comments)), _defineProperty(_ns2Collectionobject, 'computedCurrentLocation', _defineProperty({}, config, {
      cloneable: false,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.computedCurrentLocation.name',
          'defaultMessage': 'Computed current location'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'location/local,location/offsite,organization/local,organization/shared',
          readOnly: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'titleGroupList', (_titleGroupList = {}, _defineProperty(_titleGroupList, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleGroupList.name',
          'defaultMessage': 'Title'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_titleGroupList, 'titleGroup', (_titleGroup = {}, _defineProperty(_titleGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          repeating: true
        }
      }
    }), _defineProperty(_titleGroup, 'title', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.title.name',
          'defaultMessage': 'Title'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_titleGroup, 'titleLanguage', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleLanguage.name',
          'defaultMessage': 'Language'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'languages'
        }
      }
    })), _defineProperty(_titleGroup, 'titleTranslationSubGroupList', (_titleTranslationSubG2 = {}, _defineProperty(_titleTranslationSubG2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleTranslationSubGroupList.name',
          'defaultMessage': 'Translation'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_titleTranslationSubG2, 'titleTranslationSubGroup', (_titleTranslationSubG = {}, _defineProperty(_titleTranslationSubG, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_titleTranslationSubG, 'titleTranslation', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleTranslation.name',
          'defaultMessage': 'Translation'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_titleTranslationSubG, 'titleTranslationLanguage', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleTranslationLanguage.name',
          'defaultMessage': 'Language'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'languages'
        }
      }
    })), _titleTranslationSubG)), _titleTranslationSubG2)), _defineProperty(_titleGroup, 'titleType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.titleType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'titleTypes'
        }
      }
    })), _titleGroup)), _titleGroupList)), _defineProperty(_ns2Collectionobject, 'objectNameList', (_objectNameList = {}, _defineProperty(_objectNameList, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameList.name',
          'defaultMessage': 'Object name'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectNameList, 'objectNameGroup', (_objectNameGroup = {}, _defineProperty(_objectNameGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectNameGroup, 'objectName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectName.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_objectNameGroup, 'objectNameCurrency', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameCurrency.name',
          'defaultMessage': 'Currency'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'nameCurrencies'
        }
      }
    })), _defineProperty(_objectNameGroup, 'objectNameLevel', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameLevel.name',
          'defaultMessage': 'Level'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'nameLevels'
        }
      }
    })), _defineProperty(_objectNameGroup, 'objectNameSystem', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameSystem.name',
          'defaultMessage': 'System'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'nameSystems'
        }
      }
    })), _defineProperty(_objectNameGroup, 'objectNameType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'nameTypes'
        }
      }
    })), _defineProperty(_objectNameGroup, 'objectNameLanguage', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameLanguage.name',
          'defaultMessage': 'Language'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'languages'
        }
      }
    })), _defineProperty(_objectNameGroup, 'objectNameNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectNameNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectNameGroup)), _objectNameList)), _defineProperty(_ns2Collectionobject, 'copyNumber', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.copyNumber.name',
          'defaultMessage': 'Copy number'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'objectStatusList', (_objectStatusList = {}, _defineProperty(_objectStatusList, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectStatusList.name',
          'defaultMessage': 'Object status'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectStatusList, 'objectStatus', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectStatus.fullName',
          'defaultMessage': 'Object status'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'objectStatuses',
          repeating: true
        }
      }
    })), _objectStatusList)), _defineProperty(_ns2Collectionobject, 'sex', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.sex.name',
          'defaultMessage': 'Sex'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'sexes'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'phase', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.phase.name',
          'defaultMessage': 'Phase'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'phases'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'forms', (_forms = {}, _defineProperty(_forms, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.forms.name',
          'defaultMessage': 'Form'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_forms, 'form', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.form.fullName',
          'defaultMessage': 'Form'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'forms',
          repeating: true
        }
      }
    })), _forms)), _defineProperty(_ns2Collectionobject, 'editionNumber', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.editionNumber.name',
          'defaultMessage': 'Edition number'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'age', _defineProperty({}, config, {
      dataType: DATA_TYPE_INT,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.age.name',
          'defaultMessage': 'Age'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'ageQualifier', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ageQualifier.name',
          'defaultMessage': 'Qualifier'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'agequalifier'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ageUnit', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ageUnit.name',
          'defaultMessage': 'Unit'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'ageUnits'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'styles', (_styles = {}, _defineProperty(_styles, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.styles.name',
          'defaultMessage': 'Style'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_styles, 'style', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.style.fullName',
          'defaultMessage': 'Style'
        }
      }),
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _styles)), _defineProperty(_ns2Collectionobject, 'colors', (_colors = {}, _defineProperty(_colors, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.colors.name',
          'defaultMessage': 'Color'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_colors, 'color', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _colors)), _defineProperty(_ns2Collectionobject, 'materialGroupList', (_materialGroupList = {}, _defineProperty(_materialGroupList, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.materialGroupList.name',
          'defaultMessage': 'Material'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_materialGroupList, 'materialGroup', (_materialGroup = {}, _defineProperty(_materialGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_materialGroup, 'material', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.material.name',
          'defaultMessage': 'Material'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_materialGroup, 'materialComponent', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.materialComponent.fullName',
          'defaultMessage': 'Material component'
        },
        name: {
          'id': 'field.collectionobjects_common.materialComponent.name',
          'defaultMessage': 'Component'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_materialGroup, 'materialComponentNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.materialComponentNote.fullName',
          'defaultMessage': 'Material component note'
        },
        name: {
          'id': 'field.collectionobjects_common.materialComponentNote.name',
          'defaultMessage': 'Component note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_materialGroup, 'materialName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.materialName.fullName',
          'defaultMessage': 'Material name'
        },
        name: {
          'id': 'field.collectionobjects_common.materialName.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_materialGroup, 'materialSource', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.materialSource.fullName',
          'defaultMessage': 'Material source'
        },
        name: {
          'id': 'field.collectionobjects_common.materialSource.name',
          'defaultMessage': 'Source'
        }
      }),
      view: {
        type: TextInput
      }
    })), _materialGroup)), _materialGroupList)), _defineProperty(_ns2Collectionobject, 'physicalDescription', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.physicalDescription.name',
          'defaultMessage': 'Physical description'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'objectComponentGroupList', (_objectComponentGroup2 = {}, _defineProperty(_objectComponentGroup2, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectComponentGroupList.name',
          'defaultMessage': 'Object component'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectComponentGroup2, 'objectComponentGroup', (_objectComponentGroup = {}, _defineProperty(_objectComponentGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectComponentGroup, 'objectComponentName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectComponentName.fullName',
          'defaultMessage': 'Object component name'
        },
        name: {
          'id': 'field.collectionobjects_common.objectComponentName.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'objectComponentNames'
        }
      }
    })), _defineProperty(_objectComponentGroup, 'objectComponentInformation', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectComponentInformation.name',
          'defaultMessage': 'Information'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectComponentGroup)), _objectComponentGroup2)), _defineProperty(_ns2Collectionobject, 'technicalAttributeGroupList', (_technicalAttributeGr2 = {}, _defineProperty(_technicalAttributeGr2, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.technicalAttributeGroupList.name',
          'defaultMessage': 'Technical attribute'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_technicalAttributeGr2, 'technicalAttributeGroup', (_technicalAttributeGr = {}, _defineProperty(_technicalAttributeGr, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_technicalAttributeGr, 'technicalAttribute', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.technicalAttribute.fullName',
          'defaultMessage': 'Technical attribute'
        },
        name: {
          'id': 'field.collectionobjects_common.technicalAttribute.name',
          'defaultMessage': 'Attribute'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'technicalAttributes'
        }
      }
    })), _defineProperty(_technicalAttributeGr, 'technicalAttributeMeasurement', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.technicalAttributeMeasurement.name',
          'defaultMessage': 'Measurement'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'technicalAttributeMeasurements'
        }
      }
    })), _defineProperty(_technicalAttributeGr, 'technicalAttributeMeasurementUnit', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.technicalAttributeMeasurementUnit.name',
          'defaultMessage': 'Unit'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'technicalAttributeMeasurementUnits'
        }
      }
    })), _technicalAttributeGr)), _technicalAttributeGr2)), _defineProperty(_ns2Collectionobject, 'measuredPartGroupList', (_measuredPartGroupLis = {}, _defineProperty(_measuredPartGroupLis, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.measuredPartGroupList.name',
          'defaultMessage': 'Dimensions'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_measuredPartGroupLis, 'measuredPartGroup', (_measuredPartGroup = {}, _defineProperty(_measuredPartGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          repeating: true
        }
      }
    }), _defineProperty(_measuredPartGroup, 'measuredPart', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.measuredPart.name',
          'defaultMessage': 'Part'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'measuredParts'
        }
      }
    })), _defineProperty(_measuredPartGroup, 'dimensionSummary', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.dimensionSummary.name',
          'defaultMessage': 'Summary'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_measuredPartGroup, 'dimensionSubGroupList', (_dimensionSubGroupLis = {}, _defineProperty(_dimensionSubGroupLis, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.dimensionSubGroupList.name',
          'defaultMessage': 'Measurements'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_dimensionSubGroupLis, 'dimensionSubGroup', (_dimensionSubGroup = {}, _defineProperty(_dimensionSubGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_dimensionSubGroup, 'dimension', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.dimension.name',
          'defaultMessage': 'Dimension'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'dimensions'
        }
      }
    })), _defineProperty(_dimensionSubGroup, 'measuredBy', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.measuredBy.name',
          'defaultMessage': 'Measured by'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared,organization/local,organization/shared'
        }
      }
    })), _defineProperty(_dimensionSubGroup, 'measurementMethod', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.measurementMethod.name',
          'defaultMessage': 'Method'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'measurementMethods'
        }
      }
    })), _defineProperty(_dimensionSubGroup, 'value', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.value.name',
          'defaultMessage': 'Value'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_dimensionSubGroup, 'measurementUnit', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.measurementUnit.name',
          'defaultMessage': 'Unit'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'measurementUnits'
        }
      }
    })), _defineProperty(_dimensionSubGroup, 'valueQualifier', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.valueQualifier.name',
          'defaultMessage': 'Qualifier'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_dimensionSubGroup, 'valueDate', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.valueDate.name',
          'defaultMessage': 'Date'
        }
      }),
      view: {
        type: DateInput
      }
    })), _dimensionSubGroup)), _dimensionSubGroupLis)), _measuredPartGroup)), _measuredPartGroupLis)), _defineProperty(_ns2Collectionobject, 'contentDescription', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentDescription.name',
          'defaultMessage': 'Description'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'contentLanguages', (_contentLanguages = {}, _defineProperty(_contentLanguages, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentLanguages.name',
          'defaultMessage': 'Language'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentLanguages, 'contentLanguage', _defineProperty({}, config, {
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'languages',
          repeating: true
        }
      }
    })), _contentLanguages)), _defineProperty(_ns2Collectionobject, 'contentActivities', (_contentActivities = {}, _defineProperty(_contentActivities, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentActivities.name',
          'defaultMessage': 'Activity'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentActivities, 'contentActivity', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _contentActivities)), _defineProperty(_ns2Collectionobject, 'contentConcepts', (_contentConcepts = {}, _defineProperty(_contentConcepts, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentConcepts.name',
          'defaultMessage': 'Concept'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentConcepts, 'contentConcept', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.contentConcept.fullName',
          'defaultMessage': 'Content concept'
        },
        name: {
          'id': 'field.collectionobjects_common.contentConcept.name',
          'defaultMessage': 'Concept'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'concept/associated,concept/material,concept/material_shared',
          repeating: true
        }
      }
    })), _contentConcepts)), _defineProperty(_ns2Collectionobject, 'contentDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentDateGroup.name',
          'defaultMessage': 'Date'
        }
      }),
      view: {
        type: StructuredDateInput
      }
    })), _defineProperty(_ns2Collectionobject, 'contentPositions', (_contentPositions = {}, _defineProperty(_contentPositions, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentPositions.name',
          'defaultMessage': 'Position'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentPositions, 'contentPosition', _defineProperty({}, config, {
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'positions',
          repeating: true
        }
      }
    })), _contentPositions)), _defineProperty(_ns2Collectionobject, 'contentObjectGroupList', (_contentObjectGroupLi = {}, _defineProperty(_contentObjectGroupLi, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentObjectGroupList.name',
          'defaultMessage': 'Object'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentObjectGroupLi, 'contentObjectGroup', (_contentObjectGroup = {}, _defineProperty(_contentObjectGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_contentObjectGroup, 'contentObject', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentObject.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_contentObjectGroup, 'contentObjectType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentObjectType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'contentObjectTypes'
        }
      }
    })), _contentObjectGroup)), _contentObjectGroupLi)), _defineProperty(_ns2Collectionobject, 'contentPeoples', (_contentPeoples = {}, _defineProperty(_contentPeoples, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentPeoples.name',
          'defaultMessage': 'People'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentPeoples, 'contentPeople', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _contentPeoples)), _defineProperty(_ns2Collectionobject, 'contentPersons', (_contentPersons = {}, _defineProperty(_contentPersons, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentPersons.name',
          'defaultMessage': 'Person'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentPersons, 'contentPerson', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.contentPerson.fullName',
          'defaultMessage': 'Content person'
        },
        name: {
          'id': 'field.collectionobjects_common.contentPerson.name',
          'defaultMessage': 'Person'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared,person/ulan',
          repeating: true
        }
      }
    })), _contentPersons)), _defineProperty(_ns2Collectionobject, 'contentPlaces', (_contentPlaces = {}, _defineProperty(_contentPlaces, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentPlaces.name',
          'defaultMessage': 'Place'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentPlaces, 'contentPlace', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _contentPlaces)), _defineProperty(_ns2Collectionobject, 'contentScripts', (_contentScripts = {}, _defineProperty(_contentScripts, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentScripts.name',
          'defaultMessage': 'Script'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentScripts, 'contentScript', _defineProperty({}, config, {
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'scripts',
          repeating: true
        }
      }
    })), _contentScripts)), _defineProperty(_ns2Collectionobject, 'contentOrganizations', (_contentOrganizations = {}, _defineProperty(_contentOrganizations, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentOrganizations.name',
          'defaultMessage': 'Organization'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentOrganizations, 'contentOrganization', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.contentOrganization.fullName',
          'defaultMessage': 'Content organization'
        },
        name: {
          'id': 'field.collectionobjects_common.contentOrganization.name',
          'defaultMessage': 'Organization'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'organization/local,organization/shared,organization/ulan',
          repeating: true
        }
      }
    })), _contentOrganizations)), _defineProperty(_ns2Collectionobject, 'contentEventNameGroupList', (_contentEventNameGrou2 = {}, _defineProperty(_contentEventNameGrou2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentEventNameGroupList.name',
          'defaultMessage': 'Event'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentEventNameGrou2, 'contentEventNameGroup', (_contentEventNameGrou = {}, _defineProperty(_contentEventNameGrou, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_contentEventNameGrou, 'contentEventName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentEventName.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_contentEventNameGrou, 'contentEventNameType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentEventNameType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _contentEventNameGrou)), _contentEventNameGrou2)), _defineProperty(_ns2Collectionobject, 'contentOtherGroupList', (_contentOtherGroupLis = {}, _defineProperty(_contentOtherGroupLis, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentOtherGroupList.name',
          'defaultMessage': 'Other'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_contentOtherGroupLis, 'contentOtherGroup', (_contentOtherGroup = {}, _defineProperty(_contentOtherGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_contentOtherGroup, 'contentOther', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentOther.name',
          'defaultMessage': 'Name'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_contentOtherGroup, 'contentOtherType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentOtherType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _contentOtherGroup)), _contentOtherGroupLis)), _defineProperty(_ns2Collectionobject, 'contentNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.contentNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'textualInscriptionGroupList', (_textualInscriptionGr2 = {}, _defineProperty(_textualInscriptionGr2, config, {
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_textualInscriptionGr2, 'textualInscriptionGroup', (_textualInscriptionGr = {}, _defineProperty(_textualInscriptionGr, config, {
      view: {
        type: CompoundInput,
        props: {
          repeating: true
        }
      }
    }), _defineProperty(_textualInscriptionGr, 'inscriptionContent', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContent.name',
          'defaultMessage': 'Inscription content'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentInscriber', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.inscriptionContentInscriber.fullName',
          'defaultMessage': 'Textual inscription inscriber'
        },
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentInscriber.name',
          'defaultMessage': 'Inscriber'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,organization/local,organization/shared'
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentLanguage', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentLanguage.name',
          'defaultMessage': 'Language'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'languages'
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentDateGroup.name',
          'defaultMessage': 'Date'
        }
      }),
      view: {
        type: StructuredDateInput
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentPosition', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentPosition.name',
          'defaultMessage': 'Position'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'positions'
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentScript', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentScript.name',
          'defaultMessage': 'Script'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'scripts'
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'inscriptionTypes'
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentMethod', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentMethod.name',
          'defaultMessage': 'Method'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentInterpretation', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentInterpretation.name',
          'defaultMessage': 'Interpretation'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentTranslation', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentTranslation.name',
          'defaultMessage': 'Translation'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_textualInscriptionGr, 'inscriptionContentTransliteration', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionContentTransliteration.name',
          'defaultMessage': 'Transliteration'
        }
      }),
      view: {
        type: TextInput
      }
    })), _textualInscriptionGr)), _textualInscriptionGr2)), _defineProperty(_ns2Collectionobject, 'nonTextualInscriptionGroupList', (_nonTextualInscriptio2 = {}, _defineProperty(_nonTextualInscriptio2, config, {
      dataType: DATA_TYPE_LIST,
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_nonTextualInscriptio2, 'nonTextualInscriptionGroup', (_nonTextualInscriptio = {}, _defineProperty(_nonTextualInscriptio, config, {
      view: {
        type: CompoundInput,
        props: {
          repeating: true
        }
      }
    }), _defineProperty(_nonTextualInscriptio, 'inscriptionDescription', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescription.name',
          'defaultMessage': 'Inscription description'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionInscriber', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionInscriber.fullName',
          'defaultMessage': 'Non-textual inscription inscriber'
        },
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionInscriber.name',
          'defaultMessage': 'Inscriber'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared,organization/local,organization/shared'
        }
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionDateGroup.name',
          'defaultMessage': 'Date'
        }
      }),
      view: {
        type: StructuredDateInput
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionPosition', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionPosition.name',
          'defaultMessage': 'Position'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'positions'
        }
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'inscriptionTypes'
        }
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionMethod', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionMethod.fullName',
          'defaultMessage': 'Non-textual inscription method'
        },
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionMethod.name',
          'defaultMessage': 'Method'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_nonTextualInscriptio, 'inscriptionDescriptionInterpretation', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.inscriptionDescriptionInterpretation.name',
          'defaultMessage': 'Interpretation'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _nonTextualInscriptio)), _nonTextualInscriptio2)), _defineProperty(_ns2Collectionobject, 'objectProductionDateGroupList', (_objectProductionDate2 = {}, _defineProperty(_objectProductionDate2, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionDateGroupList.name',
          'defaultMessage': 'Production date'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionDate2, 'objectProductionDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectProductionDateGroup.fullName',
          'defaultMessage': 'Production date'
        }
      }),
      searchView: {
        type: DateInput
      },
      view: {
        type: StructuredDateInput,
        props: {
          repeating: true
        }
      }
    })), _objectProductionDate2)), _defineProperty(_ns2Collectionobject, 'techniqueGroupList', (_techniqueGroupList = {}, _defineProperty(_techniqueGroupList, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.techniqueGroupList.name',
          'defaultMessage': 'Production technique'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_techniqueGroupList, 'techniqueGroup', (_techniqueGroup = {}, _defineProperty(_techniqueGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_techniqueGroup, 'technique', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.technique.fullName',
          'defaultMessage': 'Production technique'
        },
        name: {
          'id': 'field.collectionobjects_common.technique.name',
          'defaultMessage': 'Technique'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_techniqueGroup, 'techniqueType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.techniqueType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _techniqueGroup)), _techniqueGroupList)), _defineProperty(_ns2Collectionobject, 'objectProductionPlaceGroupList', (_objectProductionPlac4 = {}, _defineProperty(_objectProductionPlac4, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPlaceGroupList.name',
          'defaultMessage': 'Production place'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionPlac4, 'objectProductionPlaceGroup', (_objectProductionPlac3 = {}, _defineProperty(_objectProductionPlac3, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectProductionPlac3, 'objectProductionPlace', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectProductionPlace.fullName',
          'defaultMessage': 'Production place'
        },
        name: {
          'id': 'field.collectionobjects_common.objectProductionPlace.name',
          'defaultMessage': 'Place'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_objectProductionPlac3, 'objectProductionPlaceRole', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPlaceRole.name',
          'defaultMessage': 'Role'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectProductionPlac3)), _objectProductionPlac4)), _defineProperty(_ns2Collectionobject, 'objectProductionReasons', (_objectProductionReas2 = {}, _defineProperty(_objectProductionReas2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionReasons.name',
          'defaultMessage': 'Production reason'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionReas2, 'objectProductionReason', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          multiline: true,
          repeating: true
        }
      }
    })), _objectProductionReas2)), _defineProperty(_ns2Collectionobject, 'objectProductionPeopleGroupList', (_objectProductionPeop4 = {}, _defineProperty(_objectProductionPeop4, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPeopleGroupList.name',
          'defaultMessage': 'Production people'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionPeop4, 'objectProductionPeopleGroup', (_objectProductionPeop3 = {}, _defineProperty(_objectProductionPeop3, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectProductionPeop3, 'objectProductionPeople', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectProductionPeople.fullName',
          'defaultMessage': 'Production people'
        },
        name: {
          'id': 'field.collectionobjects_common.objectProductionPeople.name',
          'defaultMessage': 'People'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_objectProductionPeop3, 'objectProductionPeopleRole', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPeopleRole.name',
          'defaultMessage': 'Role'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectProductionPeop3)), _objectProductionPeop4)), _defineProperty(_ns2Collectionobject, 'objectProductionPersonGroupList', (_objectProductionPers4 = {}, _defineProperty(_objectProductionPers4, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPersonGroupList.name',
          'defaultMessage': 'Production person'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionPers4, 'objectProductionPersonGroup', (_objectProductionPers3 = {}, _defineProperty(_objectProductionPers3, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectProductionPers3, 'objectProductionPerson', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectProductionPerson.fullName',
          'defaultMessage': 'Production person'
        },
        name: {
          'id': 'field.collectionobjects_common.objectProductionPerson.name',
          'defaultMessage': 'Person'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared'
        }
      }
    })), _defineProperty(_objectProductionPers3, 'objectProductionPersonRole', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionPersonRole.name',
          'defaultMessage': 'Role'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectProductionPers3)), _objectProductionPers4)), _defineProperty(_ns2Collectionobject, 'objectProductionOrganizationGroupList', (_objectProductionOrga4 = {}, _defineProperty(_objectProductionOrga4, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionOrganizationGroupList.name',
          'defaultMessage': 'Production organization'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_objectProductionOrga4, 'objectProductionOrganizationGroup', (_objectProductionOrga3 = {}, _defineProperty(_objectProductionOrga3, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_objectProductionOrga3, 'objectProductionOrganization', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.objectProductionOrganization.fullName',
          'defaultMessage': 'Production organization'
        },
        name: {
          'id': 'field.collectionobjects_common.objectProductionOrganization.name',
          'defaultMessage': 'Organization'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'organization/local,organization/shared'
        }
      }
    })), _defineProperty(_objectProductionOrga3, 'objectProductionOrganizationRole', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionOrganizationRole.name',
          'defaultMessage': 'Role'
        }
      }),
      view: {
        type: TextInput
      }
    })), _objectProductionOrga3)), _objectProductionOrga4)), _defineProperty(_ns2Collectionobject, 'objectProductionNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectProductionNote.name',
          'defaultMessage': 'Production note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'assocActivityGroupList', (_assocActivityGroupLi = {}, _defineProperty(_assocActivityGroupLi, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocActivityGroupList.name',
          'defaultMessage': 'Associated activity'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocActivityGroupLi, 'assocActivityGroup', (_assocActivityGroup = {}, _defineProperty(_assocActivityGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocActivityGroup, 'assocActivity', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocActivity.name',
          'defaultMessage': 'Activity'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocActivityGroup, 'assocActivityType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocActivityType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocActivityGroup, 'assocActivityNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocActivityNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocActivityGroup)), _assocActivityGroupLi)), _defineProperty(_ns2Collectionobject, 'assocObjectGroupList', (_assocObjectGroupList = {}, _defineProperty(_assocObjectGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocObjectGroupList.name',
          'defaultMessage': 'Associated object'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocObjectGroupList, 'assocObjectGroup', (_assocObjectGroup = {}, _defineProperty(_assocObjectGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocObjectGroup, 'assocObject', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocObject.name',
          'defaultMessage': 'Object'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocObjectGroup, 'assocObjectType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocObjectType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocObjectGroup, 'assocObjectNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocObjectNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocObjectGroup)), _assocObjectGroupList)), _defineProperty(_ns2Collectionobject, 'assocConceptGroupList', (_assocConceptGroupLis = {}, _defineProperty(_assocConceptGroupLis, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocConceptGroupList.name',
          'defaultMessage': 'Associated concept'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocConceptGroupLis, 'assocConceptGroup', (_assocConceptGroup = {}, _defineProperty(_assocConceptGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocConceptGroup, 'assocConcept', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.assocConcept.fullName',
          'defaultMessage': 'Associated concept'
        },
        name: {
          'id': 'field.collectionobjects_common.assocConcept.name',
          'defaultMessage': 'Concept'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'concept/associated'
        }
      }
    })), _defineProperty(_assocConceptGroup, 'assocConceptType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocConceptType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocConceptGroup, 'assocConceptNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocConceptNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocConceptGroup)), _assocConceptGroupLis)), _defineProperty(_ns2Collectionobject, 'assocCulturalContextGroupList', (_assocCulturalContext5 = {}, _defineProperty(_assocCulturalContext5, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocCulturalContextGroupList.name',
          'defaultMessage': 'Associated cultural affinity'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocCulturalContext5, 'assocCulturalContextGroup', (_assocCulturalContext4 = {}, _defineProperty(_assocCulturalContext4, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocCulturalContext4, 'assocCulturalContext', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocCulturalContext.name',
          'defaultMessage': 'Cultural affinity'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocCulturalContext4, 'assocCulturalContextType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocCulturalContextType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocCulturalContext4, 'assocCulturalContextNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocCulturalContextNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocCulturalContext4)), _assocCulturalContext5)), _defineProperty(_ns2Collectionobject, 'assocOrganizationGroupList', (_assocOrganizationGro2 = {}, _defineProperty(_assocOrganizationGro2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocOrganizationGroupList.name',
          'defaultMessage': 'Associated organization'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocOrganizationGro2, 'assocOrganizationGroup', (_assocOrganizationGro = {}, _defineProperty(_assocOrganizationGro, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocOrganizationGro, 'assocOrganization', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.assocOrganization.fullName',
          'defaultMessage': 'Associated organization'
        },
        name: {
          'id': 'field.collectionobjects_common.assocOrganization.name',
          'defaultMessage': 'Organization'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'organization/local,organization/shared'
        }
      }
    })), _defineProperty(_assocOrganizationGro, 'assocOrganizationType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocOrganizationType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocOrganizationGro, 'assocOrganizationNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocOrganizationNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocOrganizationGro)), _assocOrganizationGro2)), _defineProperty(_ns2Collectionobject, 'assocPeopleGroupList', (_assocPeopleGroupList = {}, _defineProperty(_assocPeopleGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPeopleGroupList.name',
          'defaultMessage': 'Associated people'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocPeopleGroupList, 'assocPeopleGroup', (_assocPeopleGroup = {}, _defineProperty(_assocPeopleGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocPeopleGroup, 'assocPeople', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPeople.name',
          'defaultMessage': 'People'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocPeopleGroup, 'assocPeopleType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPeopleType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocPeopleGroup, 'assocPeopleNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPeopleNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocPeopleGroup)), _assocPeopleGroupList)), _defineProperty(_ns2Collectionobject, 'assocPersonGroupList', (_assocPersonGroupList = {}, _defineProperty(_assocPersonGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPersonGroupList.name',
          'defaultMessage': 'Associated person'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocPersonGroupList, 'assocPersonGroup', (_assocPersonGroup = {}, _defineProperty(_assocPersonGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocPersonGroup, 'assocPerson', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.assocPerson.fullName',
          'defaultMessage': 'Associated person'
        },
        name: {
          'id': 'field.collectionobjects_common.assocPerson.name',
          'defaultMessage': 'Person'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared'
        }
      }
    })), _defineProperty(_assocPersonGroup, 'assocPersonType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPersonType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocPersonGroup, 'assocPersonNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPersonNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocPersonGroup)), _assocPersonGroupList)), _defineProperty(_ns2Collectionobject, 'assocPlaceGroupList', (_assocPlaceGroupList = {}, _defineProperty(_assocPlaceGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPlaceGroupList.name',
          'defaultMessage': 'Associated place'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocPlaceGroupList, 'assocPlaceGroup', (_assocPlaceGroup = {}, _defineProperty(_assocPlaceGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocPlaceGroup, 'assocPlace', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPlace.name',
          'defaultMessage': 'Place'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocPlaceGroup, 'assocPlaceType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPlaceType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocPlaceGroup, 'assocPlaceNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocPlaceNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocPlaceGroup)), _assocPlaceGroupList)), _defineProperty(_ns2Collectionobject, 'assocEventName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventName.name',
          'defaultMessage': 'Event'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'assocEventNameType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventNameType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'assocEventOrganizations', (_assocEventOrganizati2 = {}, _defineProperty(_assocEventOrganizati2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventOrganizations.name',
          'defaultMessage': 'Associated event organization'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocEventOrganizati2, 'assocEventOrganization', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventOrganization.name',
          'defaultMessage': 'Associated event organization'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'organization/local,organization/shared',
          repeating: true
        }
      }
    })), _assocEventOrganizati2)), _defineProperty(_ns2Collectionobject, 'assocEventPeoples', (_assocEventPeoples = {}, _defineProperty(_assocEventPeoples, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventPeoples.name',
          'defaultMessage': 'Associated event people'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocEventPeoples, 'assocEventPeople', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _assocEventPeoples)), _defineProperty(_ns2Collectionobject, 'assocEventPersons', (_assocEventPersons = {}, _defineProperty(_assocEventPersons, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventPersons.name',
          'defaultMessage': 'Associated event person'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocEventPersons, 'assocEventPerson', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventPerson.name',
          'defaultMessage': 'Associated event person'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared',
          repeating: true
        }
      }
    })), _assocEventPersons)), _defineProperty(_ns2Collectionobject, 'assocEventPlaces', (_assocEventPlaces = {}, _defineProperty(_assocEventPlaces, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventPlaces.name',
          'defaultMessage': 'Associated event place'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocEventPlaces, 'assocEventPlace', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _assocEventPlaces)), _defineProperty(_ns2Collectionobject, 'assocEventNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocEventNote.name',
          'defaultMessage': 'Associated event note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'assocDateGroupList', (_assocDateGroupList = {}, _defineProperty(_assocDateGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocDateGroupList.name',
          'defaultMessage': 'Associated date'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_assocDateGroupList, 'assocDateGroup', (_assocDateGroup = {}, _defineProperty(_assocDateGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_assocDateGroup, 'assocStructuredDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocStructuredDateGroup.name',
          'defaultMessage': 'Date'
        }
      }),
      view: {
        type: StructuredDateInput
      }
    })), _defineProperty(_assocDateGroup, 'assocDateType', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocDateType.name',
          'defaultMessage': 'Type'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_assocDateGroup, 'assocDateNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.assocDateNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _assocDateGroup)), _assocDateGroupList)), _defineProperty(_ns2Collectionobject, 'objectHistoryNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.objectHistoryNote.name',
          'defaultMessage': 'Object history note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'usageGroupList', (_usageGroupList = {}, _defineProperty(_usageGroupList, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.usageGroupList.name',
          'defaultMessage': 'Usage'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_usageGroupList, 'usageGroup', (_usageGroup = {}, _defineProperty(_usageGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_usageGroup, 'usage', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.usage.name',
          'defaultMessage': 'Usage'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_usageGroup, 'usageNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.usageNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _usageGroup)), _usageGroupList)), _defineProperty(_ns2Collectionobject, 'owners', (_owners = {}, _defineProperty(_owners, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.owners.name',
          'defaultMessage': 'Owner'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_owners, 'owner', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.owner.name',
          'defaultMessage': 'Owner'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared,organization/local,organization/shared',
          repeating: true
        }
      }
    })), _owners)), _defineProperty(_ns2Collectionobject, 'ownershipDateGroupList', (_ownershipDateGroupLi = {}, _defineProperty(_ownershipDateGroupLi, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipDateGroupList.name',
          'defaultMessage': 'Ownership date'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_ownershipDateGroupLi, 'ownershipDateGroup', _defineProperty({}, config, {
      view: {
        type: StructuredDateInput,
        props: {
          repeating: true
        }
      }
    })), _ownershipDateGroupLi)), _defineProperty(_ns2Collectionobject, 'ownershipAccess', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipAccess.name',
          'defaultMessage': 'Ownership access'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'ownershipAccessLevels'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipCategory', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipCategory.name',
          'defaultMessage': 'Ownership category'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'ownershipCategories'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipPlace', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipPlace.name',
          'defaultMessage': 'Ownership place'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipExchangeMethod', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipExchangeMethod.name',
          'defaultMessage': 'Method'
        }
      }),
      view: {
        type: OptionListControlledInput,
        props: {
          optionListName: 'ownershipExchangeMethods'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipExchangeNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipExchangeNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipExchangePriceCurrency', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipExchangePriceCurrency.name',
          'defaultMessage': 'Currency'
        }
      }),
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'currency'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownershipExchangePriceValue', _defineProperty({}, config, {
      dataType: DATA_TYPE_FLOAT,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownershipExchangePriceValue.name',
          'defaultMessage': 'Price'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'ownersPersonalExperience', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownersPersonalExperience.name',
          'defaultMessage': 'Owner\'s personal experience'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownersPersonalResponse', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownersPersonalResponse.name',
          'defaultMessage': 'Owner\'s personal response'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'ownersReferences', (_ownersReferences = {}, _defineProperty(_ownersReferences, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownersReferences.name',
          'defaultMessage': 'Owner\'s reference'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_ownersReferences, 'ownersReference', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _ownersReferences)), _defineProperty(_ns2Collectionobject, 'ownersContributionNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.ownersContributionNote.name',
          'defaultMessage': 'Owner\'s contribution note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'viewersRole', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.viewersRole.name',
          'defaultMessage': 'Viewer\'s role'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'viewersPersonalExperience', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.viewersPersonalExperience.name',
          'defaultMessage': 'Viewer\'s personal experience'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'viewersPersonalResponse', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.viewersPersonalResponse.name',
          'defaultMessage': 'Viewer\'s personal response'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'viewersReferences', (_viewersReferences = {}, _defineProperty(_viewersReferences, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.viewersReferences.name',
          'defaultMessage': 'Viewer\'s reference'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_viewersReferences, 'viewersReference', _defineProperty({}, config, {
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _viewersReferences)), _defineProperty(_ns2Collectionobject, 'viewersContributionNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.viewersContributionNote.name',
          'defaultMessage': 'Viewer\'s contribution note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'referenceGroupList', (_referenceGroupList = {}, _defineProperty(_referenceGroupList, config, {
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_referenceGroupList, 'referenceGroup', (_referenceGroup = {}, _defineProperty(_referenceGroup, config, {
      view: {
        type: CompoundInput,
        props: {
          tabular: true,
          repeating: true
        }
      }
    }), _defineProperty(_referenceGroup, 'reference', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.reference.name',
          'defaultMessage': 'Reference'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'citation/local,citation/shared,citation/worldcat'
        }
      }
    })), _defineProperty(_referenceGroup, 'referenceNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.referenceNote.name',
          'defaultMessage': 'Note'
        }
      }),
      view: {
        type: TextInput
      }
    })), _referenceGroup)), _referenceGroupList)), _defineProperty(_ns2Collectionobject, 'fieldCollectionDateGroup', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionDateGroup.name',
          'defaultMessage': 'Field collection date'
        }
      }),
      view: {
        type: StructuredDateInput
      }
    })), _defineProperty(_ns2Collectionobject, 'fieldCollectionMethods', (_fieldCollectionMetho2 = {}, _defineProperty(_fieldCollectionMetho2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionMethods.name',
          'defaultMessage': 'Field collection method'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_fieldCollectionMetho2, 'fieldCollectionMethod', _defineProperty({}, config, {
      view: {
        type: VocabularyControlledInput,
        props: {
          vocabularyName: 'collectionmethod',
          repeating: true
        }
      }
    })), _fieldCollectionMetho2)), _defineProperty(_ns2Collectionobject, 'fieldCollectionNote', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionNote.name',
          'defaultMessage': 'Field collection note'
        }
      }),
      view: {
        type: TextInput,
        props: {
          multiline: true
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'fieldCollectionNumber', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionNumber.name',
          'defaultMessage': 'Field collection number'
        }
      }),
      view: {
        type: TextInput
      }
    })), _defineProperty(_ns2Collectionobject, 'fieldCollectionPlace', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionPlace.name',
          'defaultMessage': 'Field collection place'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'place/local,place/shared,place/tgn'
        }
      }
    })), _defineProperty(_ns2Collectionobject, 'fieldCollectionSources', (_fieldCollectionSourc2 = {}, _defineProperty(_fieldCollectionSourc2, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionSources.name',
          'defaultMessage': 'Field collection source'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_fieldCollectionSourc2, 'fieldCollectionSource', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectionSource.name',
          'defaultMessage': 'Field collection source'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared',
          repeating: true
        }
      }
    })), _fieldCollectionSourc2)), _defineProperty(_ns2Collectionobject, 'fieldCollectors', (_fieldCollectors = {}, _defineProperty(_fieldCollectors, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollectors.name',
          'defaultMessage': 'Field collection collector'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_fieldCollectors, 'fieldCollector', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldCollector.name',
          'defaultMessage': 'Field collection collector'
        }
      }),
      view: {
        type: AutocompleteInput,
        props: {
          source: 'person/local,person/shared,organization/local,organization/shared',
          repeating: true
        }
      }
    })), _fieldCollectors)), _defineProperty(_ns2Collectionobject, 'fieldColEventNames', (_fieldColEventNames = {}, _defineProperty(_fieldColEventNames, config, {
      dataType: DATA_TYPE_LIST,
      messages: (0, _reactIntl.defineMessages)({
        name: {
          'id': 'field.collectionobjects_common.fieldColEventNames.name',
          'defaultMessage': 'Field collection event name'
        }
      }),
      view: {
        type: CompoundInput
      }
    }), _defineProperty(_fieldColEventNames, 'fieldColEventName', _defineProperty({}, config, {
      messages: (0, _reactIntl.defineMessages)({
        fullName: {
          'id': 'field.collectionobjects_common.fieldColEventName.fullName',
          'defaultMessage': 'Field collection event name'
        }
      }),
      view: {
        type: TextInput,
        props: {
          repeating: true
        }
      }
    })), _fieldColEventNames)), _ns2Collectionobject)), _document)
  };
};