'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  return function () {
    return {
      recordTypes: {
        concept: {
          serviceConfig: {
            serviceName: 'Concepts',
            servicePath: 'conceptauthorities',
            serviceType: 'authority',

            objectName: 'Conceptitem',

            documentName: 'concepts',

            quickAddData: function quickAddData(values) {
              return {
                document: {
                  '@name': 'concepts',
                  'ns2:concepts_common': {
                    '@xmlns:ns2': 'http://collectionspace.org/services/concept',
                    conceptTermGroupList: {
                      conceptTermGroup: {
                        termDisplayName: values.displayName
                      }
                    }
                  }
                }
              };
            }
          },
          messages: {
            record: (0, _reactIntl.defineMessages)({
              name: {
                'id': 'record.concept.name',
                'defaultMessage': 'Concept'
              },
              collectionName: {
                'id': 'record.concept.collectionName',
                'defaultMessage': 'Concepts'
              }
            })
          },
          forms: {
            default: _react2.default.createElement('div', null)
          },
          title: function title() {
            return '';
          },
          vocabularies: {
            all: {
              isCreatable: false,
              messages: (0, _reactIntl.defineMessages)({
                name: {
                  'id': 'vocab.concept.all.name',
                  'defaultMessage': 'All'
                },
                collectionName: {
                  'id': 'vocab.concept.all.collectionName',
                  'defaultMessage': 'All Concepts'
                }
              }),
              serviceConfig: {
                servicePath: '_ALL_'
              },
              type: 'all'
            },
            associated: {
              messages: (0, _reactIntl.defineMessages)({
                name: {
                  'id': 'vocab.concept.associated.name',
                  'defaultMessage': 'Associated'
                },
                collectionName: {
                  'id': 'vocab.concept.associated.collectionName',
                  'defaultMessage': 'Associated Concepts'
                }
              }),
              serviceConfig: {
                servicePath: 'urn:cspace:name(concept)'
              }
            },
            activity: {
              messages: (0, _reactIntl.defineMessages)({
                name: {
                  'id': 'vocab.concept.activity.name',
                  'defaultMessage': 'Activity'
                },
                collectionName: {
                  'id': 'vocab.concept.activity.collectionName',
                  'defaultMessage': 'Activity Concepts'
                }
              }),
              serviceConfig: {
                servicePath: 'urn:cspace:name(activity)'
              }
            },
            material: {
              messages: (0, _reactIntl.defineMessages)({
                name: {
                  'id': 'vocab.concept.material.name',
                  'defaultMessage': 'Material'
                },
                collectionName: {
                  'id': 'vocab.concept.material.collectionName',
                  'defaultMessage': 'Material Concepts'
                }
              }),
              serviceConfig: {
                servicePath: 'urn:cspace:name(material_ca)'
              }
            }
          }
        }
      }
    };
  };
};