'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'itemDisplayName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.itemDisplayName',
        'defaultMessage': 'Term'
      }
    }),
    width: 250
  }, {
    name: 'type',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.type',
        'defaultMessage': 'Type'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsRecordType)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'vocabulary',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.vocabulary',
        'defaultMessage': 'Vocabulary'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsVocabularyName)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'sourceField',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.sourceField',
        'defaultMessage': 'Field'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatSourceField)(value, formatterContext);
    },
    width: 250
  }],
  narrow: [{
    name: 'itemDisplayName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.itemDisplayName',
        'defaultMessage': 'Term'
      }
    }),
    width: 250
  }, {
    name: 'type',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.type',
        'defaultMessage': 'Type'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsRecordType)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'vocabulary',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.vocabulary',
        'defaultMessage': 'Vocabulary'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsVocabularyName)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'sourceField',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.terms.sourceField',
        'defaultMessage': 'Field'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatSourceField)(value, formatterContext);
    },
    width: 250
  }]
};